<?php

/**
 * @file
 * The callback file for the "Sticky Sharrre Bar" module.
 */

/**
 * Emulation functional of php file from http://sharrre.com.
 */
function sticky_sharrre_bar_handler() {
  $url = $_GET['url'];
  $type = $_GET['type'];
  $output = array('url' => $url, 'count' => 0);

  drupal_page_is_cacheable(FALSE);

  if (filter_var($url, FILTER_VALIDATE_URL)) {
    if ($type == 'googlePlus') {
      $contents = _sticky_sharrre_bar_parse('https://plusone.google.com/u/0/_/+1/fastbutton?url=' . $url . '&count=true');
      preg_match('/window\.__SSR = {c: ([\d]+)/', $contents, $matches);
      if (isset($matches[0])) {
        $output['count'] = (int) str_replace('window.__SSR = {c: ', '', $matches[0]);
      }
    }
    else {
      if ($type == 'stumbleupon') {
        $content = _sticky_sharrre_bar_parse('http://www.stumbleupon.com/services/1.01/badge.getinfo?url=' . $url);
        $result = drupal_json_decode($content);
        if (isset($result->result->views)) {
          $output['count'] = check_plain($result->result->views);
        }
      }
    }
  }

  return $output;
}

/**
 * Get necessary content use cURL.
 *
 * @param $encoded_url
 *
 * @return object
 */
function _sticky_sharrre_bar_parse($encoded_url) {
  $data = drupal_http_request($encoded_url);
  $data = $data->data;

  return $data;
}
